#ifndef OOC_CLASS_H
#define OOC_CLASS_H

#include "common.h"

/*! This is the base class of the Object Oriented C (OOC) framework.
 *  All classes are derived by this class.
 *
 */

typedef void OOC_Class_t;

void *OOC_Class_new (const OOC_Class_t *class, ...);

void OOC_Class_delete (OOC_Class_t *item);

void *OOC_Class_clone (const OOC_Class_t * self);

bool OOC_Class_differ (const OOC_Class_t *self, const OOC_Class_t *b);

size_t OOC_Class_sizeof (const OOC_Class_t *self);


#endif /* OOC_CLASS_H */
