#include <stdio.h>
#include <stdlib.h>

#include "OOC_Class.h"
#include "OOC_String.h"

int main (int argc, char **argv)
{
  OOC_String_t *a = OOC_Class_new (OOC_String, "Class A");
  OOC_String_t *aa = OOC_Class_clone(a);
  OOC_String_t *b = OOC_Class_new (OOC_String, "Class B");

  printf("ooc_sizeof(a) == %u\n", OOC_Class_sizeof(a));

  if (OOC_Class_differ(a, b))
    printf ("ok");

  if (OOC_Class_differ(a, aa))
    printf ("differ?");

  if (a == aa)
    printf ("clone?");

  OOC_String_append (a, " is the best!");
  
  printf ("a: %s\n", OOC_String_c_str (a));
  
  OOC_String_assign (a, "This is a assigned string!\n");
  
  printf ("a: %s\n", OOC_String_c_str (a));
  
  OOC_String_erase (a);
  
  printf ("a: %x\n", OOC_String_c_str (a)[0]);
  
  printf ("OOC_String_empty (a): %s\n", OOC_String_empty (a) ? "true" : "false");
  
  OOC_String_assign (a, "This is a new assigned string!");
  
  printf ("OOC_String_length (a): %d\n", OOC_String_length (a));
  
  printf ("at (a): %c\n", *OOC_String_at (a, 3));
  
  OOC_String_append_ooc (a, b);
  
  printf ("OOC_String_append_ooc (a): %s\n", OOC_String_c_str (a));

  OOC_Class_delete(a), OOC_Class_delete(aa), OOC_Class_delete(b);

  return 0;
}
